/* trace.h
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#ifndef _TRACE_H_
#define _TRACE_H_

#include "point.h"

class Trace {
private:
	//polje, na katerem se nahaja sled tock
	Point *trace_array;
	//dolzina polja sledi
	unsigned int trace_array_len;
	//mejne koordinate kjer se nahaja sled
	int min_x, min_y, max_x, max_y;
	//stevilo tock v sledi
	unsigned int nr_points;

public:
	//ustvarim novo sled
	Trace();
	//sprostim prostro
	~Trace();
	
	//postavi tocko x,y v sled na zadnje mesto
	void set_point(Point *tocka);
	//postavi tocke ki so med t1 in t2 
	void set_line(Point *t1, Point *t2);
	//vrne tocko ki je na i-tem mestu v sledi
	//NULL ce mesto ne obstaja
	Point *get_point(unsigned int index);


	//vrne zacetno tocko
	Point *get_start();
	//vrne koncno tocko
	Point *get_end();
	//vrne mejne koordinate
	unsigned int get_min_x();
	unsigned int get_min_y();
	unsigned int get_max_x();
	unsigned int get_max_y();
	//vrne stevilo tock v sledi
	unsigned int get_nr_points();
};



#endif //_TRACE_H_
