/* primitive.cpp
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#include "primitive.h"
#define ABS(a) (((a) < 0) ? -(a) : (a)) 

unsigned int Primitive::current_age = 0;

Primitive::Primitive() {
	selected = 0;
	//starost se zacne z 1 (to nam da identifikacijsko stevilko objekta)
	age = ++current_age;
	closest_point = new Point(0,0);
}


void Primitive::set_selected(unsigned char state) {
	if (state == 0) {
		selected = 0;
	} else {
		selected = 1;
	}
}

void Primitive::set_youngest()
{
	age = ++current_age;
}


unsigned char Primitive::is_selected() {
	return selected;
}

unsigned int Primitive::get_age() {
	return age;
}

unsigned int Primitive::diff(Point *t1, Point *t2) {
	//Algorithm credits to Po-Han Lin http://www.edepot.com
	unsigned int len = 0;
	bool yLonger=false;
	int incrementVal, endVal;
	int shortLen= t2->y - t1->y;
	int longLen= t2->x - t1->x;
	int decInc;
	int j = 0;
	
	if (shortLen == 0 && longLen == 0)
		return 0;

	if (ABS(shortLen) > ABS(longLen)) {
		int swap = shortLen;
		shortLen = longLen;
		longLen = swap;
		yLonger = true;
	}

	endVal = longLen;
	
	if (longLen < 0) {
		incrementVal = -1;
		longLen = -longLen;
	} else 
		incrementVal = 1;

	if (longLen == 0) 
		decInc = 0;
	else 
		decInc = (shortLen << 16) / longLen;

	if (yLonger) {	
		for (int i = 0; i != endVal; i +=  incrementVal) {
			len++;
			j += decInc;
		}
	} else {
		for (int i = 0; i != endVal; i += incrementVal) {
			len++;
			j += decInc;
		}
	}

	return len;
}

Point *Primitive::get_closest_point() {
	return closest_point;
}